unit uAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, HeaderFrame, GraphUtil;

type
  TfrmAbout = class(TForm)
    RarusComponetHeader1: TRarusComponetHeader;
    bvlAbout: TBevel;
    Timer: TTimer;
    TimerPause: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerPauseTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    FScreenLeft: Integer;
    FScreenTop: Integer;
    FScreenWidth: Integer;
    FScreenHeight: Integer;
    FScreenRect: TRect;
    FPic: TBitMap;
    FTmpBmp: TBitMap;
    FSourceRect: TRect;
    FDestinationRect: TRect;
    FTopPosition: Integer;
    FCadrs: Integer;
    FCadr: Integer;
    procedure PrintText;
    procedure SetScreenSize;
  public
    { Public declarations }
  end;


implementation

const
  TEXT_OFFSET = 50;
  OFFSET = 2;
  arrStrings: array[0..11] of string = (
    '1-:     . 8',
    '      ',
    '----------------------------------------------------------------------------------------------',
    '    (. . )',
    '125047, . , . ,  15,  5,  10',
    ': (495) 250-6383, 250-6393, 223-0404',
    '-mail: 1c@rarus.ru',
    '',
    '     (. . )',
    '. , .  , . 68',
    ': (495) 250-6383, 250-6393, 223-0404',
    '-mail: 1c@rarus.ru'
    );
{$R *.dfm}

procedure TfrmAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmAbout.FormCreate(Sender: TObject);
var
  I, H: Integer;
  R: TRect;
begin
  RarusComponetHeader1.ProductName := '   ';
  SetScreenSize;
  FPic := TBitMap.Create;
  FPic.Canvas.Font.Assign(Font);
  with FPic.Canvas.Font do begin
    Size := 9;
  end;
  FPic.Width := FScreenWidth;
  FPic.Height := FScreenHeight * 3;
  FPic.Canvas.Brush.Color := Color;
//  FPic.Canvas.FillRect(Bounds(0, 0, FPic.Width, FPic.Height));
  R := Rect(0, 0, FPic.Width, FPic.Height);
  GradientFillCanvas(FPic.Canvas, clWindow, clBtnFace, R, gdHorizontal);
  SetBkMode(FPic.Canvas.Handle, TRANSPARENT);
  PrintText;
  FDestinationRect := Bounds(0, 0, FScreenWidth, FScreenHeight);
  FCadr := 0;
  FCadrs := bvlAbout.Height * 2;
  FSourceRect := Bounds(0, FCadr, FPic.Width, FPic.Height div 3);
  FTmpBmp := TBitMap.Create;
  FTmpBmp.Width := FScreenWidth;
  FTmpBmp.Height := FScreenHeight;
  FTmpBmp.Canvas.CopyRect(FDestinationRect, FPic.Canvas, FSourceRect);
end;

procedure TfrmAbout.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FPic);
  FreeAndNil(FTmpBmp);
end;

procedure TfrmAbout.FormPaint(Sender: TObject);
begin
  BitBlt(Canvas.Handle, FScreenLeft, FScreenTop, FTmpBmp.Width, FTmpBmp.Height, FTmpBmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

procedure TfrmAbout.PrintText;
var
  I, iTop: Integer;
  S: string;
begin
  iTop := FPic.Height div 3;
  for I := 0 to Length(arrStrings) - 1 do begin
    if I < 1 then FPic.Canvas.Font.Style := [fsBold]
    else FPic.Canvas.Font.Style := [];

    S := arrStrings[I];
    FPic.Canvas.TextOut(TEXT_OFFSET, iTop + I * FPic.Canvas.TextHeight(S), S);
  end;
end;

procedure TfrmAbout.SetScreenSize;
begin
  FScreenLeft := bvlAbout.Left + OFFSET;
  FScreenTop := bvlAbout.Top + OFFSET;
  FScreenWidth := bvlAbout.Width - OFFSET * 2;
  FScreenHeight := bvlAbout.Height - OFFSET * 2;
  FScreenRect := Rect(FScreenLeft, FScreenTop, FScreenLeft + FScreenWidth, FScreenTop + FScreenHeight);
end;

procedure TfrmAbout.TimerPauseTimer(Sender: TObject);
begin
  Timer.Enabled := True;
  TimerPause.Enabled := False;
end;

procedure TfrmAbout.TimerTimer(Sender: TObject);
begin
  FTmpBmp.Canvas.CopyRect(FDestinationRect, FPic.Canvas, FSourceRect);
  InvalidateRect(Self.Handle, @FScreenRect, False);

  Inc(FCadr);
  if FCadr >= FCadrs then FCadr := 0
  else if FCadr = (FPic.Height div 3 - 5) then begin
    Timer.Enabled := False;
    TimerPause.Enabled := True;
  end;

  FSourceRect := Bounds(0, FCadr, FPic.Width, FPic.Height div 3);
end;

end.

